"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/helptips/BaseOnoardingTip.tsx
var BaseOnoardingTip_exports = {};
__export(BaseOnoardingTip_exports, {
  BaseOnboardingTip: () => BaseOnboardingTip,
  BaseOnboardingTooltip: () => BaseOnboardingTooltip,
  default: () => BaseOnoardingTip_default,
  orientations: () => orientations
});
module.exports = __toCommonJS(BaseOnoardingTip_exports);
var import_react = __toESM(require("react"), 1);
var import_react_redux = require("react-redux");
var import_icons_material = require("@mui/icons-material");
var import_material = require("@mui/material");
var import_mui = require("tss-react/mui");
var import_common_ui = require("@northern.tech/common-ui");
var import_actions = __toESM(require("@northern.tech/store/actions"), 1);
var import_constants = require("@northern.tech/store/constants");
var import_helpers = require("@northern.tech/utils/helpers");
var import_tracking = __toESM(require("@northern.tech/utils/tracking"), 1);
var import_jsx_runtime = require("react/jsx-runtime");
var { setShowDismissOnboardingTipsDialog } = import_actions.default;
var iconWidth = 30;
var orientations = {
  top: {
    arrow: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_icons_material.ArrowUpward, {}),
    placement: "bottom",
    offsetStyle: (style) => {
      style.left = style.left - iconWidth / 2;
      return style;
    }
  },
  right: {
    arrow: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_icons_material.ArrowBack, {}),
    placement: "right",
    offsetStyle: (style) => {
      style.top = style.top - iconWidth / 2;
      style.left = style.left + iconWidth / 2;
      return style;
    }
  },
  bottom: {
    arrow: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_icons_material.ArrowDownward, {}),
    placement: "top",
    offsetStyle: (style) => {
      style.left = style.left - iconWidth / 2;
      return style;
    }
  },
  left: {
    arrow: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_icons_material.ArrowForward, {}),
    placement: "left",
    offsetStyle: (style) => {
      style.top = style.top - iconWidth / 2;
      return style;
    }
  }
};
var useStyles = (0, import_mui.makeStyles)()((theme) => ({
  root: {
    [`.${import_material.buttonBaseClasses.root}.${import_material.buttonClasses.text}`]: { color: theme.palette.background.paper, paddingRight: 0 }
  }
}));
var BaseOnboardingTooltip = ({ anchor = { left: 0, top: 0 }, icon, children, id = "1", place = "top", ...props }) => {
  const [open, setOpen] = (0, import_react.useState)(false);
  const showDismissHelptipsDialog = (0, import_react_redux.useSelector)((state) => state.onboarding.showTipsDialog);
  const showDeviceConnectionDialog = (0, import_react_redux.useSelector)((state) => state.users.showConnectDeviceDialog);
  const delayTimer = (0, import_react.useRef)();
  const { classes } = useStyles();
  (0, import_react.useEffect)(() => {
    import_tracking.default.event({ category: "onboarding", action: id });
    clearTimeout(delayTimer.current);
    delayTimer.current = setTimeout(() => setOpen(true), import_constants.TIMEOUTS.debounceShort);
    return () => {
      clearTimeout(delayTimer.current);
    };
  }, [id]);
  const toggleVisibility = () => setOpen(import_helpers.toggle);
  const hide = () => setOpen(false);
  if (showDismissHelptipsDialog || showDeviceConnectionDialog) {
    return null;
  }
  const orientation = orientations[place];
  const style = orientation.offsetStyle({ left: anchor.left, top: anchor.top, overflow: "initial" });
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    import_common_ui.OnboardingTooltip,
    {
      disableFocusListener: true,
      disableHoverListener: true,
      disableTouchListener: true,
      id,
      onClose: hide,
      open,
      placement: orientation.placement,
      PopperProps: {
        className: classes.root,
        disablePortal: true,
        popperOptions: {
          strategy: "fixed",
          modifiers: [
            { name: "flip", enabled: false },
            { name: "preventOverflow", enabled: true, options: { boundary: window, altBoundary: false } }
          ]
        }
      },
      title: children,
      className: classes.root,
      ...props,
      children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { className: "onboard-tip", onClick: toggleVisibility, style, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { className: `tooltip onboard-icon ${orientation.placement}`, children: icon ?? orientation.arrow }) })
    }
  );
};
var BaseOnboardingTip = ({ anchor, icon, component, place, id, ...others }) => {
  const dispatch = (0, import_react_redux.useDispatch)();
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(BaseOnboardingTooltip, { anchor, icon, place, id, children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("div", { className: "content", children: [
    import_react.default.cloneElement(component, others),
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)("b", { className: "clickable", onClick: () => dispatch(setShowDismissOnboardingTipsDialog(true)), children: "Dismiss the tutorial" }) })
  ] }) });
};
var BaseOnoardingTip_default = BaseOnboardingTip;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  BaseOnboardingTip,
  BaseOnboardingTooltip,
  orientations
});
//# sourceMappingURL=BaseOnoardingTip.cjs.map